;; Copyright (C) 2005, 2006, 2007, 2008, 2010, 2011, 2012
;; Free Software Foundation, Inc.
;;
;; This file is part of GCC.
;;
;; GCC is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 3, or (at your option)
;; any later version.
;;
;; GCC is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GCC; see the file COPYING3.  If not see
;; <http://www.gnu.org/licenses/>.

;; MIPS DSP ASE Revision 0.98 3/24/2005
(define_c_enum "unspec" [
  UNSPEC_ADDQ
  UNSPEC_ADDQ_S
  UNSPEC_SUBQ
  UNSPEC_SUBQ_S
  UNSPEC_ADDSC
  UNSPEC_ADDWC
  UNSPEC_MODSUB
  UNSPEC_RADDU_W_QB
  UNSPEC_ABSQ_S
  UNSPEC_PRECRQ_QB_PH
  UNSPEC_PRECRQ_PH_W
  UNSPEC_PRECRQ_RS_PH_W
  UNSPEC_PRECRQU_S_QB_PH
  UNSPEC_PRECEQ_W_PHL
  UNSPEC_PRECEQ_W_PHR
  UNSPEC_PRECEQU_PH_QBL
  UNSPEC_PRECEQU_PH_QBR
  UNSPEC_PRECEQU_PH_QBLA
  UNSPEC_PRECEQU_PH_QBRA
  UNSPEC_PRECEU_PH_QBL
  UNSPEC_PRECEU_PH_QBR
  UNSPEC_PRECEU_PH_QBLA
  UNSPEC_PRECEU_PH_QBRA
  UNSPEC_SHLL
  UNSPEC_SHLL_S
  UNSPEC_SHRL_QB
  UNSPEC_SHRA_PH
  UNSPEC_SHRA_R
  UNSPEC_MULEU_S_PH_QBL
  UNSPEC_MULEU_S_PH_QBR
  UNSPEC_MULQ_RS_PH
  UNSPEC_MULEQ_S_W_PHL
  UNSPEC_MULEQ_S_W_PHR
  UNSPEC_DPAU_H_QBL
  UNSPEC_DPAU_H_QBR
  UNSPEC_DPSU_H_QBL
  UNSPEC_DPSU_H_QBR
  UNSPEC_DPAQ_S_W_PH
  UNSPEC_DPSQ_S_W_PH
  UNSPEC_MULSAQ_S_W_PH
  UNSPEC_DPAQ_SA_L_W
  UNSPEC_DPSQ_SA_L_W
  UNSPEC_MAQ_S_W_PHL
  UNSPEC_MAQ_S_W_PHR
  UNSPEC_MAQ_SA_W_PHL
  UNSPEC_MAQ_SA_W_PHR
  UNSPEC_BITREV
  UNSPEC_INSV
  UNSPEC_REPL_QB
  UNSPEC_REPL_PH
  UNSPEC_CMP_EQ
  UNSPEC_CMP_LT
  UNSPEC_CMP_LE
  UNSPEC_CMPGU_EQ_QB
  UNSPEC_CMPGU_LT_QB
  UNSPEC_CMPGU_LE_QB
  UNSPEC_PICK
  UNSPEC_PACKRL_PH
  UNSPEC_EXTR_W
  UNSPEC_EXTR_R_W
  UNSPEC_EXTR_RS_W
  UNSPEC_EXTR_S_H
  UNSPEC_EXTP
  UNSPEC_EXTPDP
  UNSPEC_SHILO
  UNSPEC_MTHLIP
  UNSPEC_WRDSP
  UNSPEC_RDDSP
])

(define_constants
  [(CCDSP_PO_REGNUM	182)
   (CCDSP_SC_REGNUM	183)
   (CCDSP_CA_REGNUM	184)
   (CCDSP_OU_REGNUM	185)
   (CCDSP_CC_REGNUM	186)
   (CCDSP_EF_REGNUM	187)])

;; This mode iterator allows si, v2hi, v4qi for all possible modes in DSP ASE.
(define_mode_iterator DSP [(SI "ISA_HAS_DSP")
			   (V2HI "ISA_HAS_DSP")
		 	   (V4QI "ISA_HAS_DSP")])

;; This mode iterator allows v2hi, v4qi for vector/SIMD data.
(define_mode_iterator DSPV [(V2HI "ISA_HAS_DSP")
			    (V4QI "ISA_HAS_DSP")])

;; This mode iterator allows si, v2hi for Q31 and V2Q15 fixed-point data.
(define_mode_iterator DSPQ [(SI "ISA_HAS_DSP")
			    (V2HI "ISA_HAS_DSP")])

;; DSP instructions use q for fixed-point data, and u for integer in the infix.
(define_mode_attr dspfmt1 [(SI "q") (V2HI "q") (V4QI "u")])

;; DSP instructions use nothing for fixed-point data, and u for integer in
;; the infix.
(define_mode_attr dspfmt1_1 [(SI "") (V2HI "") (V4QI "u")])

;; DSP instructions use w, ph, qb in the postfix.
(define_mode_attr dspfmt2 [(SI "w") (V2HI "ph") (V4QI "qb")])

;; DSP shift masks for SI, V2HI, V4QI.
(define_mode_attr dspshift_mask [(SI "0x1f") (V2HI "0xf") (V4QI "0x7")])

;; MIPS DSP ASE Revision 0.98 3/24/2005
;; Table 2-1. MIPS DSP ASE Instructions: Arithmetic
;; ADDQ*

abstract parallel_set_plus2_set_unspec2 extends parallel {
  root.1:=set_plus2; root.2:=set_unspec2;
}

concrete add<DSPV:mode>3.insn instantiates parallel_set_plus2_set_unspec2 {
  root (register_operand:DSPV:"=d", register_operand:DSPV:"d", 
    register_operand:DSPV:"d", reg(CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_ADDQ>));
    root.1.2.mode:=DSPV; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "add<DSPV:dspfmt1>.<DSPV:dspfmt2>\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
abstract parallel_set_unspec2_x2 extends parallel {
  root.1:=set_unspec2; root.2:=set_unspec2;
}

concrete mips_add<DSP:dspfm1>_s_<DSP:dspfmt2> instantiates parallel_set_unspec2 {
  root (register_operand:DSP:"=d", (register_operand:DSP:"d", registere_operand:DSP:"d",
    <UNSPEC_ADDQ_S>), reg (CCDSP:CCDSP_OU_REGNUM), (duplicate 1, duplicate 2,
    <UNSPEC_ADDQ_S>)); root.1.2.mode:=DSP; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "add<DSP:dspfmt1>_s.<DSP:dspfmt2>\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; SUBQ*
:}
abstract parallel_set_minus2_set_unspec2 extends parallel {
  root.1:=set_minus2; root.2:=set_unspec2;
}
concrete sub<DSPV:mode>3.insn instantiates parallel_set_minus2_set_unspec2 {
  root (register_operand:DSPV:"=d", register_operand:DSPV:"d",
    register_operand:DSPV:"d", reg(CCDSP:CCDSP_OU_REGNUM), 
    (duplicate 1, duplicate 2, <UNSPEC_SUBQ>));
  root.1.2.mode:=DSPV; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "sub<DSPV:dspfmt1>.<DSPV:dspfmt2>\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_sub<DSP:dspfmt1>_s_<DSP:dspfmt2>.insn instantiates parallel_set_unspec2_x2 {
  root  (register_operand:DSP:"=d", (register_operand:DSP:"d",
    register_operand:DSP:"d", <UNSPEC_SUBQ_S>), reg(CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_SUBQ_S>));
  root.1.2.mode:=DSP; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "sub<DSP:dspfmt1>_s.<DSP:dspfmt2>\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; ADDSC
:}
concrete mips_addsc.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:SI:"=d", (register_operand:SI:"d", register_operand:SI:"d",
    <UNSPEC_ADDSC>), reg(CCDSP:CCDSP_CA_REGNUM), (duplicate 1,
    duplicate 2,  <UNSPEC_ADDSC>)); root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "addsc\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; ADDWC
:}

concrete mips_addwc.insn instantiates parallel_set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:SI:"d",
    register_operand:SI:"d", reg(CCDSP:CCDSP_CA_REGNUM), <UNSPEC_ADDWC>),
    reg (CCDSP:CCDS_OU_REGNUM), (duplicat 1, duplicate 2,
    <UNSPEC_ADDWC>)); root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "addwc\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; MODSUB
:}
concrete mips_modsub.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:SI:"d",
    register_operand:SI:"d", <UNSPEC_MODSUB>));
  root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "modsub\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; RADDU*
:}
concrete mips_raddu_w_qb.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_RADDU_W_QB>)); root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "raddu.w.qb\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; ABSQ*
:}
concrete mips_absq_s_<DSPQ:dspfmt2>.insn instantiates parallel_set_unspec2 {
  root (register_operand:DSPQ:"=d", register-operand:DSPQ:"d", <UNSPEC_ABSQ_S>),
    reg(CCDSP:CCDSP_OU_REGNUM), (duplicate 1, <UNSPEC_ABSQ_S>));
}
{:
  "ISA_HAS_DSP"
  "absq_s.<DSPQ:dspfmt2>\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PRECRQ*
:}
concrete mips_precrq_qb_ph.insn instantiates set_unspec2 {
  root (register_operand:V4QI:"=d", (register_operand:V2HI:"d",
    register_operand:V2HI:"d", <UNSPEC_PRECRQ_QB_PH>));
  root.2.mode:=V4QI;
}
{:
  "ISA_HAS_DSP"
  "precrq.qb.ph\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_precrq_ph_w.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:SI:"d",
    register_operand:SI:"d", <UNSPEC_PRECRQ_PH_W>));
  root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "precrq.ph.w\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}

concrete mips_precrq_rs_ph_w.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:V2HI:"=d", (register_operand:SI:"d", register_operand:SI:"d",
    <UNSPEC_PRECRQ_RS_PH_W>), reg(CCDSP:CCDSP_OU_REGNUM), (duplicate 1,
    duplicate 2, <UNSPEC_PRECRQ_RS_PH_W>)); root.1.2.mode:=V2HI;
  root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "precrq_rs.ph.w\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PRECRQU*
:}
concrete mips_precrqu_s_qb_ph.insn instantiates parallel_set_unspec_x2 {
  root (register_operand:V4QI:"=d", register_operand:V2HI:"d",
    register_operand:V2HI:"d", <UNSPEC_PRECRQU_S_QB_PH>),
    (reg (CCDSP:CCDSP_OU_REGNUM), duplicate 1, 
    duplicate 2 , <UNSPEC_PRECRQU_S_QB_PH>)); root.1.2.mode:=V4QI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "precrqu_s.qb.ph\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PRECEQ*
:}
concrete mips_preceq_w_phl.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:V2HI:"d",
    <UNSPEC_PRECEQ_W_PHL>));
}
{:
  "ISA_HAS_DSP"
  "preceq.w.phl\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_precq_w_phr.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:V2HI:"d",
    <UNSPEC_PRECEQ_W_PHR>)); root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "preceq.w.phr\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PRECEQU*
:}
concrete mips_precequ_ph_qbl.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEQU_PH_QBL>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "precequ.ph.qbl\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_precequ_ph_qbr.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEQU_PH_QBR>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "precequ.ph.qbr\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_precequ_ph_qbla.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEQU_PH_QBLA>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "precequ.ph.qbla\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_precequ_ph_qbra.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEQU_PH_QBRA>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "precequ.ph.qbra\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PRECEU*
:}
concrete mips_preceu_ph_qbl.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEU_PH_QBL>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "preceu.ph.qbl\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_preceu_ph_qbr.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEU_PH_QBR>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "preceu.ph.qbr\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_preceu_ph_qbla.insn instantiates set_unsepc2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEU_PH_QBLA>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "preceu.ph.qbla\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_preceu_ph_qbra.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    <UNSPEC_PRECEU_PH_QBRA>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "preceu.ph.qbra\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; Table 2-2. MIPS DSP ASE Instructions: Shift
;; SHLL*
:}
concrete mips_shll_<DSPV:dspfmt2>.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DSPV:"=d,d", (register_operand:DSPV:"d,d",
    <UNSPEC_SHLL>), reg(CCDSP:CCDSP_OU_REGNUM), (duplicate 1,
    duplicate 2, <UNSPEC_SHLL)); root.1.2.mode:=DSPV; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2])
	  & ~(unsigned HOST_WIDE_INT) <DSPV:dspshift_mask>)
	operands[2] = GEN_INT (INTVAL (operands[2]) & <DSPV:dspshift_mask>);
      return "shll.<DSPV:dspfmt2>\t%0,%1,%2";
    }
  return "shllv.<DSPV:dspfmt2>\t%0,%1,%2";
}
  [(set_attr "type"	"shift")
   (set_attr "mode"	"SI")]
:}
concrete mips_shll_s_<DSPQ:dspfm2>.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DSPQ:"=d,d", (register_operand:DSPQ:"d,d",
    arith_operand:SI:"I,d", <UNSPEC_SHLL_S>), reg(CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_SHLL_S>)); root.1.2.mode:=DSPQ;
    root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2])
          & ~(unsigned HOST_WIDE_INT) <DSPQ:dspshift_mask>)
	operands[2] = GEN_INT (INTVAL (operands[2]) & <DSPQ:dspshift_mask>);
      return "shll_s.<DSPQ:dspfmt2>\t%0,%1,%2";
    }
  return "shllv_s.<DSPQ:dspfmt2>\t%0,%1,%2";
}
  [(set_attr "type"	"shift")
   (set_attr "mode"	"SI")]
:}
{:
;; SHRL*
:}
concrete mips_shrl_qb.insn  instantiates set_unspec2 {
  root (register_operand:V4QI:"=d,d", (register_operand:V4QI:"d,d",
    arith_operand:SI:"I,d", <UNSPEC_SHRL_QB>)); root.2.mode:=V4QI;
}
{:
  "ISA_HAS_DSP"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x7)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x7);
      return "shrl.qb\t%0,%1,%2";
    }
  return "shrlv.qb\t%0,%1,%2";
}
  [(set_attr "type"	"shift")
   (set_attr "mode"	"SI")]
:}
{:
;; SHRA*
:}
concrete mips_shra_ph.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d,d", (register_operand:V2HI:"d,d",
    arith_operand:SI:"I,d",<UNSPEC_SHRA_PH>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0xf)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0xf);
      return "shra.ph\t%0,%1,%2";
    }
  return "shrav.ph\t%0,%1,%2";
}
  [(set_attr "type"	"shift")
   (set_attr "mode"	"SI")]
:}
concrete mips_shra_r_<DSPQ:dspfm2>.insn instantiates set_unspec2 {
  root (register_operand:DSPQ:"=d,d", (register_operand:DSPQ:"d,d",
    arith_operand:SI:"I,d", <UNSPEC_SHRA_R>)); root.2.mode:=DSPQ;
}
{:
  "ISA_HAS_DSP"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2])
	  & ~(unsigned HOST_WIDE_INT) <DSPQ:dspshift_mask>)
	operands[2] = GEN_INT (INTVAL (operands[2]) & <DSPQ:dspshift_mask>);
      return "shra_r.<DSPQ:dspfmt2>\t%0,%1,%2";
    }
  return "shrav_r.<DSPQ:dspfmt2>\t%0,%1,%2";
}
  [(set_attr "type"	"shift")
   (set_attr "mode"	"SI")]
:}
{:
;; Table 2-3. MIPS DSP ASE Instructions: Multiply
;; MULEU*
:}
abstract parallel_set_unspec2_x2_clobber extends parallel {
  root.1:=set_unspec2; root.2:=set_unspec2; root.3:=clobber;
}

concrete mips_muleu_s_ph_qbl.insn instantiates parallel_set_unspec2_x2_clobber {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    register_operand:V2HI:"d", <UNSPEC_MULEU_S_PH_QBL>), 
    reg (CCDSP:CCDSP_OU_REGNUM), (duplicate 1, duplicate 2, 
    <UNSPEC_MULEU_S_PH_QBL>), 3=DI:"=x"); root.1.2.mode:=V2HI;
  root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "muleu_s.ph.qbl\t%0,%1,%2"
  [(set_attr "type"	"imul3")
   (set_attr "mode"	"SI")]
:}

concrete mips_muleu_s_ph_qbr.insn instantiates parallel_set_unspec2_x2_clobber {
  root (register_operand:V2HI:"=d", (register_operand:V4QI:"d",
    register_operand:V2HI:"d", <UNSPEC_MULEU_S_PH_QBR>),
    reg(CCDSP:CCDSP_OU_REGNUM), (duplicate 1, duplicate 2, <UNSPEC_MULEU_S_PH_QBR>),
    3=DI:"=x"); root.1.2.mode:=V2HI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "muleu_s.ph.qbr\t%0,%1,%2"
  [(set_attr "type"	"imul3")
   (set_attr "mode"	"SI")]
:}
{:
;; MULQ*
:}

concrete mips_mulq_rs_ph.insn instantiates parallel_set_unspec2_clobber {
  root (register_operand:V2HI:"=d", (register_operand:V2HI:"d",
    register_operand:V2HI:"d", <UNSPEC_MULQ_RS_PH>), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_MULQ_RS_PH>), 3=DI:"=x");
  root.1.2.mode:=V2HI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "mulq_rs.ph\t%0,%1,%2"
  [(set_attr "type"	"imul3")
   (set_attr "mode"	"SI")]
:}
{:
;; MULEQ*
:}
concrete mips_muleq_s_w_phl.insn instantiates parallel_set_unspec2_x2_clobber {
  root (register_operand:SI:"=d", (register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_MULEQ_S_W_PHL>), reg(CCDSP:CCDSP_OU_REGNUM), (duplicate 1,
    duplicate 2, <UNSPEC_MULEQ_S_W_PHL>), 3=DI:"=x");
  root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "muleq_s.w.phl\t%0,%1,%2"
  [(set_attr "type"	"imul3")
   (set_attr "mode"	"SI")]
:}

concrete mips_muleq_s_w_phr.insn isntantiates parallel_set_unspec2_x2_clobber {
  root (register_operand:SI:"=d", (register_operand:V2HI:"d", 
    regiser_operand:V2HI:"d", "UNSPEC_MULEQ_S_W_PHR"), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_MULEQ_S_W_PHR>), 3=DI:"=x");
  root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "muleq_s.w.phr\t%0,%1,%2"
  [(set_attr "type"	"imul3")
   (set_attr "mode"	"SI")]
:}
{:
;; DPAU*
:}
concrete mips_dpau_h_qbl.insn instantiates set_unspec2 {
  root (register_operand:DI:"=a", (register-operand:DI:"0",
    register_operand:V4QI:"d", register_operand:V4QI:"d",
    <UNSPEC_DPAU_H_QBL>)); root.2.mode:=DI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpau.h.qbl\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
concrete mips_dpau_h_qbr.insn instantiates set_unspec2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V4QI:"d", register_operand:V4QI:"d",
    <UNSPEC_DPAU_H_QBR>)); root.2.mode:=DI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpau.h.qbr\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; DPSU*
:}
concrete mips_dpsu_h_qbl.insn instantiates set_unspec2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V4QI:"d", register_operand:V4QI:"d",
    <UNSPEC_DPSU_H_QBL>)); root.2.mode:=DI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpsu.h.qbl\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}

concrete mips_dpsu_h_qbr.insn instantiates set_unspec2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V4QI:"d", register_Oprand:V4QI:"d",
    <UNSPEC_DPSU_H_QBR>)); root.2.mode:=DI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpsu.h.qbr\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; DPAQ*
:}

concrete mips_dpaq_s_w_ph.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_DPAQ_S_W_PH>), reg(CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, duplicate 3, <UNSPEC_DPAQ_S_W_PH>));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpaq_s.w.ph\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; DPSQ*
:}
concrete mips_dpsq_s_w_ph.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0", 
    register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_DPSQ_S_W_PH>), reg(CCDSP:CCDSP_OU_REGNUM),  
    (duplicate 1, duplicate 2, duplicate 3, <UNSPEC_DPSQ_S_W_PH>));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpsq_s.w.ph\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; MULSAQ*
:}
concrete mips_mulsaq_s_w_ph.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0", register_operand:V2HI:"d",
    register_operand:V2HI:"d", <UNSPEC_MULSAQ_S_W_PH>), 
    reg (CCDSP:CCDSP_OU_REGNUM), (duplicate 1, duplicate 2, duplicate 3, 
    <UNSPEC_MULSAQ_S_W_PH>)); root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "mulsaq_s.w.ph\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")])
:}
{:
;; DPAQ*
:}
concrete mips_dpaq_sa_l_w.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:SI:"d", register_operand:SI:"d", <UNSPEC_DPAQ_SA_L_W>),
    reg (CCDSP:CCDSP_OU_REGNUM), (duplicate 1, duplicate 2, duplicate 3,
    <UNSPEC_DPAQ_SA_L_W>)); root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpaq_sa.l.w\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; DPSQ*
:}
concrete mips_dpsq_sa_l_w.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:SI:"d", register_operand:SI:"d",
    <UNSPEC_DPSQ_SA_L_W>), reg (CCDSP:CCDSP_OU_REGNUM), 
    (duplicate 1, duplicate 2, duplicate 3, <UNSPEC_DPSQ_SA_L_W>));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "dpsq_sa.l.w\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; MAQ*
:}
concrete mips_maq_s_w_phl.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_MAQ_S_W_PHL>), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, duplicate 3, <UNSPEC_MAQ_S_W_PHL));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "maq_s.w.phl\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
concrete mips_maq_s_w_phr.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_MAQ_S_W_PHR>), reg (CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, duplicate 3, <UNSPEC_MAQ_S_W_PHR>));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "maq_s.w.phr\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; MAQ_SA*
:}
concrete mips_maq_sa_w_phl.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_MAQ_SA_W_PHL>), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, duplicate 3, <UNSPEC_MAQ_SA_W_PHL>));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "maq_sa.w.phl\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
concrete mips_maq_sa_w_phr.insn instantiates parallel_set_unspec2_x2 {
  root (regoster_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:V2HI:"d", register_operand:V2HI:"d",
    <UNSPEC_MAQ_SA_W_PHR>), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1,duplicate 2, duplicate 3, <UNSPEC_MAQ_SA_W_PHR>));
  root.1.2.mode:=DI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "maq_sa.w.phr\t%q0,%2,%3"
  [(set_attr "type"	"imadd")
   (set_attr "mode"	"SI")]
:}
{:
;; Table 2-4. MIPS DSP ASE Instructions: General Bit/Manipulation
;; BITREV
:}
concrete mips_bitrev.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:SI:"d",
    <UNSPEC_BITREV>)); root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "bitrev\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; INSV
:}
concrete mips_insv.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:SI:"0",
    register_operand:SI:"d", reg (CCDSP:CCDS_CS_REGNUM),
    reg (CCDSP:CCDSP_PO_REGNUM), <UNSPEC_INSV>));
  root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "insv\t%0,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; REPL*
:}
concrete mips_repl_qb.insn instantiates set_unspec2 {
  root (register_operand:V4QI:"=d,d", (arith_operand:SI:"I,d",
    <UNSPEC_REPL_QB>)); root.2.mode:=V4QI;
}
{:
  "ISA_HAS_DSP"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[1]) & ~(unsigned HOST_WIDE_INT) 0xff)
	operands[1] = GEN_INT (INTVAL (operands[1]) & 0xff);
      return "repl.qb\t%0,%1";
    }
  return "replv.qb\t%0,%1";
}
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_repl_ph.insn instantiates set_unspec2 {
  ROOT (register_operand:V2HI:"=d,d", (reg_imm10_operand:SI:"YB,d",
    <UNSPEC_REPL_PH>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "@
   repl.ph\t%0,%1
   replv.ph\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; Table 2-5. MIPS DSP ASE Instructions: Compare-Pick
;; CMPU.* CMP.*
:}
concrete mips_cmp<DSPV:dspfmt1_1>_eq_<DSPV:dspfmt2>.insn instantiates set_unspec2 {
  root (reg (CCDSP:CCDSP_CC_REGNUM), (register_operand:DSPV:"d",
    register_operand:DSPV:"d", reg (CCDSP:CCDSP_CC_REGNUM),
    <UNSPEC_CMP_EQ>)); root.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "cmp<DSPV:dspfmt1_1>.eq.<DSPV:dspfmt2>\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_cmp<DPSV:dspfmt1_1>_lt_<DSPV:dspfmt2>.insn instantiates set_unspec2 {
  root (reg (CCDSP:CCDSP_CC_REGNUM), (register_operand:DSPV:"d",
    register_operand:DSPV:"d", reg (CCDSP:CCDSP_CC_REGNUM), 
    <UNSPEC_CMP_LT>)); root.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "cmp<DSPV:dspfmt1_1>.lt.<DSPV:dspfmt2>\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_cmp<DSPV:dspfmt1_1>_le_<DSPv:dspfmt2>.insn instantiates set_unspec2  {
  root (reg (CCDSP:CCDSP_CC_REGNUM), (register_operand:DSPV:"d",
    register_operand:DSPV:"d", reg (CCDPS:CCDSP_CC_REGNUM), 
    <UNSPEC_CMP_LE>)); root.2.mode:= CCDSP;
}
{:
  "ISA_HAS_DSP"
  "cmp<DSPV:dspfmt1_1>.le.<DSPV:dspfmt2>\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_cmpgu_eq_qb.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:V4QI:"d",
    register_operand:V4QI:"d", <UNSPEC_CMPGU_EQ_QB>));
}
{:
  "ISA_HAS_DSP"
  "cmpgu.eq.qb\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_cmpgu_lt_qb.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:V4QI:"d",
    register_operand:V4QI:"d", <UNSPEC_CMPGU_LT_QB>));
  root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "cmpgu.lt.qb\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
concrete mips_cmpgu_le_qb.insn instantiates set_unspec2 {
  root (register_operand:SI:"=d", (register_operand:V4QI:"d",
    register_operand:V4QI:"d", <UNSPEC_CMPGU_LE_QB>)); root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "cmpgu.le.qb\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PICK*
:}
concrete mips_pick_<DSPV:dspfmt2>.insn instantiates set_unspec2 {
  root (register_operand:DSPV:"=d", register_operand:DSPV:"d",
    register_operand:DSPV:"d", reg (CCDSP:CCDSP_CC_REGNUM),
    <UNSPEC_PICK>); root.2.mode:=DSPV;
}
{:
  "ISA_HAS_DSP"
  "pick.<DSPV:dspfmt2>\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; PACKRL*
:}
concrete mips_packrl_ph.insn instantiates set_unspec2 {
  root (register_operand:V2HI:"=d", (register_operand:V2HI:"d",
    register_operand:V2HI:"d", <UNSPEC_PACKRL_PH>)); root.2.mode:=V2HI;
}
{:
  "ISA_HAS_DSP"
  "packrl.ph\t%0,%1,%2"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; Table 2-6. MIPS DSP ASE Instructions: Accumulator and DSPControl Access
;; EXTR*
:}
concrete mips_extr_w.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:SI:"=d,d", (register_operand:DI:"a,a",
    arith_operand:SI:"I,d", <UNSPEC_EXTR_W>), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_EXTR_W>));
  root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x1f)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
      return "extr.w\t%0,%q1,%2";
    }
  return "extrv.w\t%0,%q1,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
concrete mips_extr_r_w.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:SI:"=d,d", (register_operand:DI:"a,a",
    arith_oeprand:SI:"I,d", <UNSPEC_EXTR_R_W>), reg (CCDSP:CCDSP_OU_REGNUM)
    (duplocate 1, duplicate 2, <UNSPEC_EXTRA_R_W>));
  root.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x1f)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
      return "extr_r.w\t%0,%q1,%2";
    }
  return "extrv_r.w\t%0,%q1,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}

concrete mips_extr_rs_w.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:SI:"=d,d", (register_operand:DI:"a,a",
    arith_operand:SI:"I,d", <UNSPEC_EXTR_RS_W>), reg(CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_EXTR_RS_W>)); 
  root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x1f)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
      return "extr_rs.w\t%0,%q1,%2";
    }
  return "extrv_rs.w\t%0,%q1,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
{:
;; EXTR*_S.H
:}
concrete mips_extr_s_h.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:SI:"=d,d", (register_operand:DI:"a,a",
    arith_operand:SI:"I,d", <UNSPEC_EXTR_S_H>), reg (CCDSP:CCDSP_OU_REGNUM),
    (duplicate 1, duplicate 2, UNSPEC_EXTR_S_H));
  root.1.2.mode:=SI; root.2.2.mode:=CCSDP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x1f)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
      return "extr_s.h\t%0,%q1,%2";
    }
  return "extrv_s.h\t%0,%q1,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
{:
;; EXTP*
:}
concrete mips_extp.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:SI:"=d,d", (register_operand:DI:"a,a",
    reg(CCDSP:CCDSP_PO_REGNUM), <UNSPEC_EXTP>), reg (CCDSP:CCDSP_EF_REGNUM),
    (duplicate 1, duplicate 2, <UNSPEC_EXTP>));
  root.1.2.mode:=SI; root.2.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x1f)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
      return "extp\t%0,%q1,%2";
    }
  return "extpv\t%0,%q1,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
concrete mips_extpdp.insn instantiates parallel_set_unspec2_x3 {
  root (register_operand:DI:"=d,d", (register_operand:DI:"a,a",
    arith_operand:SI:"I,d", reg(CCDSP:CCDSP_PO_REGNUM), <UNSPEC_EXTPDP>),
    reg (CCDSP:CCDSP_PO_REGNUM), (duplicate 1, duplicate 2,
    reg (CCDSP:CCDSP_PO_REGNUM), <UNSPEC_EXTPDP>),
    reg (CCDSP:CCDSP_EF_REGNUM), (duplicate 1, duplicate 2, <UNSPEC_EXTPDP>));
  root.1.2.mode:=SI; root.2.2.mode:=CCDSP; root.3.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) & ~(unsigned HOST_WIDE_INT) 0x1f)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x1f);
      return "extpdp\t%0,%q1,%2";
    }
  return "extpdpv\t%0,%q1,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
{:
;; SHILO*
:}
concrete mips_shilo.insn instantiates set_unspec2 {
  root (register_operand:DI:"=a,a", (register_operand:DI:"0,0",
    arith_operand:SI:"I,d", <UNSPEC_SHILO>)); root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
{
  if (which_alternative == 0)
    {
      if (INTVAL (operands[2]) < -32 || INTVAL (operands[2]) > 31)
	operands[2] = GEN_INT (INTVAL (operands[2]) & 0x3f);
      return "shilo\t%q0,%2";
    }
  return "shilov\t%q0,%2";
}
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
{:
;; MTHLIP*
:}
concrete mips_mthlip.insn instantiates parallel_set_unspec2_x2 {
  root (register_operand:DI:"=a", (register_operand:DI:"0",
    register_operand:SI:"d', reg (CCDPS:CCDSP_PO_REGNUM),
    <UNSPCE_MTHLIP>), reg (CCDSP:CCDSP_PO_REGNUM),
    (duplicate 1, duplicate 2, reg (CCDSP:CCSDP_PO_REGNUM),
    <UNSPEC_MTHLIP>)); root.1.2.mode:=DI; root.2.2mode:=CCDSP;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
  "mthlip\t%2,%q0"
  [(set_attr "type"	"mfhilo")
   (set_attr "mode"	"SI")]
:}
{:
;; WRDSP
:}
concrete mips_wrdsp.insn instantiates parallel_set_unsec2_x6 {
	root (reg (CCDSP:CCDSP_PO_REGNUM), (register_operand:SI:"d",
		const_uimm6_operand:SI:"YA", <UNSPEC_WRDSP>), reg (CCDSP:CCDSP_SC_REGNUM),
		(duplicate 0, duplicate 1, <UNSPEC_WRDSP>), reg (CCDSP:CCDSP_CA_REGNUM),
		(duplicate 0, duplicate 1, <UNSPEC_WRDSP>), reg (CCDSP:CCDSP_OU_REGNUM),
		(duplicate 0, duplicate 1, <UNSPEC_WRDSP>), reg (CCDSP:CCDSP_CC_REGNUM),
		(duplicate 0, duplicate 1, <UNSPEC_WRDSP>), reg (CCDSP:CCDSP_EF_REGNUM),
		(duplicate 0, duplicate 1, <UNSPEC_WRDSP>));
	root.1.2.mode:=CCDSP; root.2.2.mode:=CCDSP; root.3.2.mode:=CCDSP;
	root.4.2.mode:=CCDSP; root.5.2.mode:=CCDSP; root.6.2.mode:=CCDSP;
}
{:
  "ISA_HAS_DSP"
  "wrdsp\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; RDDSP
:}
concrete mips_rddsp.insn instantiates set_unspec2 {
	root (register_operand:SI:"=d", (const_uimm6_operand:SI:"YA",
		reg(CCDSP:CCDSP_PO_REGNUM), reg(CCDSP:CCDSP_SC_REGNUM), 
		reg(CCDSP:CCDSP_CA_REGNUM), reg(CCDSP:CCDSP_OU_REGNUM), 
		reg(CCDSP:CCDSP_CC_REGNUM), reg(CCDSP:CCDSP_EF_REGNUM)));
	root.2.mode:=SI;
}
{:
  "ISA_HAS_DSP"
  "rddsp\t%0,%1"
  [(set_attr "type"	"arith")
   (set_attr "mode"	"SI")]
:}
{:
;; Table 2-7. MIPS DSP ASE Instructions: Indexed-Load
;; L*X
:}
concrete mips_lbux.exp instaniates sequence {
	root (regsiter_operand:SI:"", pmode_register_operand:NULL:"",
		register_operand:SI:"");
}
{:
  "ISA_HAS_DSP"
{
  operands[2] = convert_to_mode (Pmode, operands[2], false);
  emit_insn (PMODE_INSN (gen_mips_lbux_extsi,
			 (operands[0], operands[1], operands[2])));
  DONE;
}
:}
concrete mips_l<SHORT:size><u>x_ext<GPR:mode>_<P:mode>.insn
intantiates set_any_extend2_mem1_plus1 {
	root (register_operand:GPR:"=d", register_operand:P:"d",
		register_operand:P:"d"); root.2.mode:=GPR;
	root.2.1.mode:=SHORT; root.2.1.1.mode:=P;
}
{:
  "ISA_HAS_L<SHORT:SIZE><U>X"
  "l<SHORT:size><u>x\t%0,%2(%1)"
  [(set_attr "type"	"load")
   (set_attr "mode"	"<GPR:MODE>")
   (set_attr "length"	"4")]
:}
concrete mips_lhx.exp instantiates sequence {
	root (register_operand:SI:"", pmode_register_operand:NULL:"",
	register_operand:SI:"");
}
{:
  "ISA_HAS_DSP"
{
  operands[2] = convert_to_mode (Pmode, operands[2], false);
  emit_insn (PMODE_INSN (gen_mips_lhx_extsi,
			 (operands[0], operands[1], operands[2])));
  DONE;
}
:}

concrete mips_l<size>x.exp overrides mips_lhx.exp {
	root.1.mode:=GPR;
}
{:
  "ISA_HAS_DSP"
{
  operands[2] = convert_to_mode (Pmode, operands[2], false);
  emit_insn (PMODE_INSN (gen_mips_l<size>x,
			 (operands[0], operands[1], operands[2])));
  DONE;
}
:}

concrete mips_l<GPR:size>x_<P:mode>.insn instantiates set_mem2_plus1 {
	root (register_operand:GPR:"=d", register_operand:P:"d",
		register_operand:P:"d"); root.2.mode:=GPR; root.2.1.mode:=P;
}
{:
  "ISA_HAS_L<GPR:SIZE>X"
  "l<GPR:size>x\t%0,%2(%1)"
  [(set_attr "type"	"load")
   (set_attr "mode"	"<GPR:MODE>")
   (set_attr "length"	"4")]
:}

concrete *mips_lw<U>x_<P:mode>_ext.insn overrides
mips_l<SHORT:size><u>x_ext<GPR:mode>_<P:mode>.insn {
	root.1.mode:=DI; root.2.mode:=DI; root.2.1.mode:=SI;
}
{:
  "ISA_HAS_LW<U>X && TARGET_64BIT"
  "lw<u>x\t%0,%2(%1)"
  [(set_attr "type"	"load")
   (set_attr "mode"	"DI")
   (set_attr "length"	"4")]
:}
{:
;; Table 2-8. MIPS DSP ASE Instructions: Branch
;; BPOSGE32
:}
concrete mips_bposge.insn instantiates set_if_then_else2_ge1_label_ref2 {
	root (pc, reg (CCDSP:CCDSP_PO_REGNUM), 1=immediate_operand:SI:"I",
		0=NULL:NULL:"", pc); 
}
{:
  "ISA_HAS_DSP"
  "%*bposge%1\t%0%/"
  [(set_attr "type"	"branch")]
:}
concrete mips_madd<u>.exp instantiates set_plus2_mult1_any_extend1_any_extend2 {
	root (0=register_operand:DI:"", 2=register_operand:SI:"",
		3=register_operand:SI:"", 1=register_operand:DI:"");
	root.2.mode:=DI; root.2.1.mode:=DI; root.2.1.1.mode:=DI;
	root.2.1.2.mode:=DI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
:}
concrete mips_msub<u>.exp instantiates set_minus2_mult2_any_extend1_any_extend2 {
	root (reister_operand:DI:"", register_operand:DI:"", 
		register_operand:SI:"" register_operand:SI:"");
	root.2.mode:=DI; root.2.1.mode:=DI; root.2.1.1.mode:=DI;
	root.2.1.2.mode:=DI;
}
{:
  "ISA_HAS_DSP && !TARGET_64BIT"
:}
